/*ESSE ARQUIVO CONTEM UM PSEUDO CODIGO EM C, NAO TENTE COMPILAR ELE
  NAO IRA FUNCIONAR, O PROGRAMA FUNCIONAL SE CHAMA meu_malloc.s 
  ESSE ARQUIVO E APENAS UM MOLDE PARA O SEU SEMELHANTE EM ASSEMBLY
*/

short int livre = 1
short int ocupado = 0
void* piso_heap = 0
void* teto_heap = 0;
//variavel local
int alocador = 1040
void* endr;

//inicializa a heap utilizando a brk
void iniciaAlocador()
{	
	endr = sbrk(0)		//endr na posicao corrente da heap
	piso_heap = endr;	
	endr += alocador;	//soma 1040 a posicao de endr
	teto_heap = endr;	
	brk(endr);			//aloca endr.
	endr = piso_heap;
	*endr = 1;
	8(endr) = alocador - 16;
	
	return;
}

void finalizaAlocador()
{
	//se existe o piso da heap	
	if (piso_heap)
	{
		//retorno brk para o inicio da heap		
		brk(piso_heap)
		//coloca os paramentros novamente em 0 (necessario?)		
		teto_heap = 0;	
		piso_heap = 0;	
	}	
	
	return;
}

void aloca_espaco(void tam_alloc)
{
	teto_heap += tam_alloc+16;
	brk(teto_heap);
	
	return;
}

void* meuMalloc(int tam_alloc)
{
	
	//se a heap n esta inicializada
	if(piso_heap == 0)
		iniciaAlocador();
	
	endr = piso_heap;

	while (endr <= teto_heap)
	{
		//endereco livre		
		if((*endr == LIVRE))
		{
			//verifica se tem espaco
			if (8(endr) >= tam_alloc)
			{			
				//8(endr) = valor contido dentro desse espaço de memoria				
				8(endr) -= tam_alloc + 16;
				tam_atual = 8(endr)
				endr += 16 + tam_atual;
				(endr) = OCUPADO;
				8(endr) = tam_alloc;		
			}
			else
			{
				endr = teto_heap;
				aloca_espaco(tam_alloc);
				(endr) = OCUPADO;
				8(endr) = tam_alloc;			
			}			
			break;		
		}		
		//endereco ocupado		
		endr += 8(endr) + 16
	}	
	
	return (endr + 16);
}

void arruma_heap()
{
	void *endr_ant, *endr; 

	endr_ant = piso_heap;
	endr = piso_heap + 8(endr_ant) + 16;
	while (endr < teto_heap)
	{
		if ((endr == 1) && ((endr_ant) == 1))
			8(endr_ant) += 8(endr) + 16;
		else
			endr_ant = endr;

		endr += 8(endr) + 16;
	}

	return;
}

void meuFree(*void bloco)
{
	//bloco livre	
	-16(bloco) = livre;
	arruma_heap();	

	return;
}

//printa o conteudo da heap cabecalho(##), espaço alocado vazio(--), 
//espaço alocado ocupado(**) 
void print_mapa()
{
	int i;
	void* endr;	
	
	if (piso_heap == 0)
	{
		printf("NAO EXISTE ESPACO ALOCADO!\n");	
		return;	
	}	
	endr = piso_heap;
	while (endr < teto_heap)	
	{
		//imprime o cabecalho		
		for (i = 0; i < 16; i++)
			printf("#");	
		
		//imprime o conteudo		
		if ((endr == LIVRE))				
			//livre			
			for (i = 0; i < 8(endr); i++)
				printf("-");
		else	
			//ocupado			
			for (i = 0; i < 8(endr); i++)
				printf("*");
		
		endr += 8(endr) + 16;			
	}

	return;
}
