#ifndef __MEU_MALLOC__
#define __MEU_MALLOC__

//inicia o alocador chamando a brk e atribuindo um valor pre determinado
void iniciaAlocador();

//finaliza o alocador voltando a heap para o seu inicio
void finalizaAlocador();

//Pede mais espaco na heap ao sistema operacional quando necessario
void aloca_espaco(int tam_alloc);

//Aloca o ponteiro na heap
void* meuMalloc(int tam_alloc);

//rearranja os elementos dentro da heap liberando espacos desnecessarios
void arruma_heap();

//libera o ponteiro da heap
void meuFree(void* bloco);

//escreve o estado atual da heap
void imprimeMapa();

#endif